module FileUtils where
import Prelude hiding (readFile,writeFile,
		       putStr,putStrLn,getLine,readLn,print,
		       catch,ioError)
import qualified Prelude
import Monad(unless)
import MUtils(( # ),done)
import AbstractIO

-- Write to the file only if the new contents is different from the old:
updateFile path contents =
  do unchanged <- ((contents==)#readFile path) `catch` const (return False)
     unless unchanged $
          do -- GHC lingering file lock workaround:
             removeFile path `catch` const done -- grr!
             writeFile path contents
     return unchanged

-- Write to the file, even if the new contents is the same:
updateFile' path contents =
  do unchanged <- ((contents==)#readFile path) `catch` const (return False)
     -- GHC lingering file lock workaround:
     removeFile path `catch` const done -- grr!
     writeFile path contents
     return unchanged

readFileMaybe path = maybeM (read # readFile path)
   -- lazy error checking for efficiency

readM s =
  case reads s of
    [(x,[])] -> return x
    []       -> fail "FileUtils.readM: no parse"
    _        -> fail "FileUtils.readM: ambiguous parse"

--readLn = readM =<< getLine
print = putStrLn . show
